package de.andrena.springbootadvancedtesting.booking;

import de.andrena.springbootadvancedtesting.swapiclient.StarwarsStarship;

public class Starship {

	private String name;

	public Starship() {
	}

	public Starship(StarwarsStarship starwarsStarship) {
		this(starwarsStarship.getName());
	}

	public Starship(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Starship other = (Starship) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}
}
